/* SALSA/World Wide Computer Porject
 *
 * Reference Server - Remote Message Sending Protocol Daemon
 * In order to deliver a message to a remote actor, messengers
 * reach this daemon (that can also host actors) to get the (unique)
 * hash code of the target actor. The rmspd is in charge to forward
 * messengers to the target's stage (rmspd's host or remote applet).
 *
 * By Gregory Haik and Carlos Varela.  v0.1  June, 1999
 *
 */
package wwc.messaging;

import wwc.util.ObjectiveRequest;

/**
 * Defines the request sent to the rmspd when an actor has enters a stage
 * handled by the rmspd.
 */
public class IncomingActorNotification extends ObjectiveRequest {
    String relativeUAL;
    RegisteryEntry registeryEntry;

    public IncomingActorNotification(String senderHostname,
				     int senderPortNumber,
				     String localUAL,
				     int hashcode) {
	this(senderHostname, senderPortNumber, localUAL, null, 0, hashcode);
    }

    public IncomingActorNotification(String hostname,
				     int portNumber,
				     String localUAL,
				     String appletHostname,
				     int appletPortNumber,
				     int hashcode) {
	senderHostname = hostname;
	senderPortNumber = portNumber;
	relativeUAL = localUAL;
	registeryEntry = new RegisteryEntry(appletHostname,
					    appletPortNumber,
					    hashcode);
    }

    public String getRelativeUAL() {
	return relativeUAL;
    }
    
    public RegisteryEntry getRegisteryEntry() {
	return registeryEntry;
    }
}
