package wwc.messaging;

import salsa.language.UniversalActor;

/**
	This interface defines the basic methods that any theater must provide. Each theater
	must pass a reference to itself to incoming actors using the UniversalActor.resolveActorState( Theater )
	method.
*/
public interface Theater {

	/**
		This method returns the port that the theater is currently listening on i.e. 4040.
	*/
	public int getPort();

	/**
		This method returns a reference to the universal actor at the specified ual or null of the
		actor does not exist.
	*/
	public UniversalActor getActorUAL( String relativeUAL );
};