package wwc.util;

import java.net.Socket;
import java.io.*;

/**
 * Generic shape that any request sent to a server using
 * an ObjectInputGate should inherit from. It contains enough
 * data for the server to reply a complain.
 */
public class ObjectiveRequest implements Serializable {
    protected int senderPortNumber;
    protected String senderHostname;

    public int getSenderPortNumber() {
	return senderPortNumber;
    }

    public String getSenderHostname() {
	return senderHostname;
    }

/**
 * unsafe : the complain might not be delivered !!!
 *
 */
    public void complain(String s) {
	try {
	     Socket socket = new Socket(senderHostname, senderPortNumber);
	     ObjectOutputStream out = new ObjectOutputStream(
			      	      new BufferedOutputStream(socket.getOutputStream()));
	     RemoteException remoteException = new RemoteException(s);
	     out.writeObject(remoteException);
	     out.close();
	     socket.close();
	} catch (IOException e) {}
    }
}

    
